<?php
/*
 *
 * @package		ARI Smart Content Load Module plugin
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemAriSmartContentloadmodule extends JPlugin
{
	var $_isComponentInstalled = null;
	var $_loaded = false;

	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config); 
	}

	function onContentPrepare($context, &$article, &$params)
	{
		if ($this->getMode() != 'content' || !$this->needToProcess($article->text))
			return ;

		$article->text = $this->processContent($article->text);
	}

	function onAfterRender()
	{
		if ($this->getMode() == 'content')
			return ;
		
		$option = JRequest::getString('option');

		$document = JFactory::getDocument();
		if ($document->getType() == 'pdf')
			return ;

		$mainframe = JFactory::getApplication();
		if ($mainframe->isAdmin()) 
			return ;

		if ($option == 'com_content' && JRequest::getString('view') == 'form' && JRequest::getString('layout') == 'edit')
			return ;		

		$content = JResponse::getBody();
		if (!$this->needToProcess($content))
			return ;
                   
    $this->_load();
		AriKernel::import('Document.DocumentIncludesManager');

		$includesManager = new AriDocumentIncludesManager();

		JResponse::setBody(
			$this->processContent(
				$content
			)
		);

		$includes = $includesManager->getDifferences();
		AriDocumentHelper::addCustomTagsToDocument($includes);
	}

	function processContent($content)
	{
		$this->_load();

		$plg = new AriContentPlugin('arimodule');
		$content = $plg->parse($content, array($this, 'handleModule'));

		return $content;
	}

	function getMode()
	{
		$mode = $this->params->get('pluginMode', 'content');
		
		return $mode;
	}

	function needToProcess($content)
	{ 
		return (strpos($content, '{arimodule') !== false && $this->_isAriSmartContentInstalled());
	}
	
	function handleModule($params, $content, $sourceContent)
	{
		$modContent = '';

		if (empty($params['id']))
			return $modContent;

		$module =& AriModuleHelper::getModuleById(intval($params['id'], 10));
		if (empty($module))
			return $modContent;

        $oldGlobalVars = isset($GLOBALS['ASC_VARS']) ? $GLOBALS['ASC_VARS'] : null;

        $GLOBALS['ASC_VARS'] = array();
        if (count($params) > 1)
        {
            foreach ($params as $paramKey => $paramVal)
            {
                if ($paramKey == 'id')
                    continue ;

                $GLOBALS['ASC_VARS'][$paramKey] = $paramVal;
            }
        }

        $modContent = AriModuleHelper::renderModule($module);

        if (!is_null($oldGlobalVars))
            $GLOBALS['ASC_VARS'] = $oldGlobalVars;
        else
            unset($GLOBALS['ASC_VARS']);

        return $modContent;
	}
	
	function _isAriSmartContentInstalled()
	{
		if (is_null($this->_isComponentInstalled))
		{
			$adminBasePath = JPATH_ADMINISTRATOR . '/components/com_arismartcontent';

			$this->_isComponentInstalled = @file_exists($adminBasePath); 
		}

		return $this->_isComponentInstalled; 
	}
	
	function _load()
	{
		if ($this->_loaded)
			return ;
		
		require_once JPATH_ADMINISTRATOR . '/components/com_arismartcontent/kernel/class.AriKernel.php';
		
		AriKernel::import('Module.ModuleHelper');
		AriKernel::import('Plugin.ContentPlugin');
		
		$this->_loaded = true;
	}
}