<?php
/*
 *
 * @package		ARI Smart Content
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

(defined('_JEXEC') && defined('ARI_FRAMEWORK_LOADED')) or die;

AriKernel::import('Application.ARISmartContent.Controllers.Controller');
AriKernel::import('Web.Controls.Data.MultiPageDataTable');
AriKernel::import('Data.DataFilter');
AriKernel::import('Utils.ArrayHelper');
//provider_database_group_connectionlist
class AriSmartContentProviderGroupListBase extends AriSmartContentController 
{
	var $_itemName = null;
	var $_group = null;

	protected function getItemName()
	{
		if (is_null($this->_itemName))
		{
			$name = $this->getOriginalName();
			$this->_itemName = preg_replace('/list$/', '', $name);
		}

		return $this->_itemName;
	}
	
	protected function getGroup()
	{
		if (is_null($this->_group))
		{
			$itemName = $this->getItemName();
			$itemName = explode('_', $itemName);
			$this->_group = $itemName[1] . '_' . $itemName[3];
		}

		return $this->_group;
	}
	
	protected function getModelInstance()
	{
		return $this->getModel('Providersettings');
	}
	
	protected function getStateKey()
	{
		return 'com_arismartcontent.' . $this->getOriginalName();
	}

	function add()
	{
		$this->redirect('index.php?option=com_arismartcontent&view=' . $this->getItemName() . '&task=add');
	}

	function edit()
	{
		$itemId = JRequest::getVar('Id');
		if (is_array($itemId) && count($itemId) > 0)
			$itemId = $itemId[0];

		$itemId = intval($itemId, 10);

		$this->redirect('index.php?option=com_arismartcontent&view=' . $this->getItemName() . '&task=edit&Id=' . $itemId);
	}

	function ajaxGetItemList()
	{
		$model = $this->getModelInstance();

		$filter = new AriDataFilter(
			array(
				'startOffset' => 0, 
				'limit' => 10, 
				'sortField' => 'Name', 
				'dir' => 'asc'
			), 
			true, 
			$this->getStateKey()
		);

		$totalCnt = $model->getSettingsCount($this->getGroup(), $filter);
		$filter->fixFilter($totalCnt);
		$items = $model->getSettingsList($this->getGroup(), $filter);

		$data = AriMultiPageDataTableControl::createDataInfo($items, $filter, $totalCnt); 

		return $data;
	}

	function ajaxDelete()
	{
		$idList = AriArrayHelper::toInteger(JRequest::getVar('Id'), 1);
		if (count($idList) == 0) 
			return false;

		$model = $this->getModelInstance();

		return $model->delete($this->getGroup(), $idList);
	}
	
	function ajaxMarkAsDefault()
	{
		$id = JRequest::getInt('id');
		if ($id < 1)
			return false;
		
		$model = $this->getModelInstance();

		return $model->markAsDefault($this->getGroup(), $id);
	}
}