<?php
/*
 *
 * @package		ARI Smart Content
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

(defined('_JEXEC') && defined('ARI_FRAMEWORK_LOADED')) or die;

AriKernel::import('Application.ARISmartContent.Controllers.Controller');
//provider_database_source_query
class AriSmartContentProviderSourceBase extends AriSmartContentController 
{
	var $_itemListName;
	var $_itemName = null;
	var $_type = null;
	var $_providerSettingsFormName = null;
	var $_formatterFormName = null;

	protected function getFormatterFormName()
	{
		return $this->_formatterFormName; 
	}
	
	protected function getProviderSettingsFormName()
	{
		return $this->_providerSettingsFormName;
	}
	
	protected function getItemName()
	{
		if (is_null($this->_itemName))
			$this->_itemName = $this->getOriginalName();

		return $this->_itemName;
	}
	
	protected function getItemListName()
	{
		if (is_null($this->_itemListName))
		{
			$name = $this->getOriginalName();
			$this->_itemListName = $name . 'list';
		}

		return $this->_itemListName;
	}
	
	protected function getType()
	{
		if (is_null($this->_type))
		{
			$itemName = $this->getItemName();
			$itemName = explode('_', $itemName);
			$this->_type = $itemName[1] . '_' . $itemName[3];
		}

		return $this->_type;
	}
	
	protected function getModelInstance()
	{
		return $this->getModel('Providersource');
	}
	
	function display() 
	{
		$this->redirect('index.php?option=com_arismartcontent&view=' . $this->getItemListName());
	}
	
	function add() 
	{
		$model = $this->getModelInstance();
		$item = $model->getTable();

		$data = $this->getRequestData();
		if (!is_null($data))
			$item->bind($data);

		$view = $this->getView($this->getOriginalName());
		$view->display($item, $this->getProviderSettingsFormName(), $this->getFormatterFormName());
	}

	function edit()
	{
		$id = JRequest::getInt('Id');
		$model = $this->getModelInstance();
		$item = $model->getSource($id, $this->getType());
		$set = $item->ProviderSettings;

		if (is_null($item))
		{
			JError::raiseError(
				500, 
				JText::sprintf(
					'COM_ARISMARTCONTENT_ERROR_LOAD_PROVIDERSOURCE', 
					__CLASS__ . '::' . __FUNCTION__ . '()', 
					$id
				)
			);
			
			return ;
		}

		$data = $this->getRequestData();
		if (!is_null($data))
			$item->bind($data);

		$view = $this->getView($this->getOriginalName());
		$view->display($item, $this->getProviderSettingsFormName(), $this->getFormatterFormName());
	}

	function apply()
	{
		JRequest::checkToken() or jexit('Invalid Token');

		$item = $this->_save();  
    
    $input = JFactory::getApplication()->input;
    $directEdit = $input->get('direct', null, 'bool');
    $callback = $input->get('callback', null, 'callback');
		$this->redirect('index.php?option=com_arismartcontent&view=' . $this->getItemName() . '&task=edit&Id=' . $item->Id . ($directEdit ? '&direct=1' : '') . ($callback ? '&callback=' . $callback : '') . '&saved=1&__MSG=COM_ARISMARTCONTENT_COMPLETE_PROVIDERSOURCESAVE');
	}

	function save()
	{
		JRequest::checkToken() or jexit('Invalid Token');
		
		$this->_save();
		
		$input = JFactory::getApplication()->input;
		$rurl = $input->get('rurl', null, 'RAW');
		if ($rurl)
			$rurl = base64_decode($rurl);
		else 
			$rurl = 'index.php?option=com_arismartcontent&view=' . $this->getItemName() . '&__MSG=COM_ARISMARTCONTENT_COMPLETE_PROVIDERSOURCESAVE';
		
		$this->redirect($rurl);
	}

    function save2copy()
    {
        JRequest::checkToken() or jexit('Invalid Token');

        $item = $this->_save(true, true);
        $this->redirect('index.php?option=com_arismartcontent&view=' . $this->getItemName() . '&task=edit&Id=' . $item->Id . '&__MSG=COM_ARISMARTCONTENT_COMPLETE_PROVIDERSOURCESAVE');
    }

	function cancel()
	{
		$input = JFactory::getApplication()->input;
		$rurl = $input->get('rurl', null, 'RAW');

		if ($rurl)
			$rurl = base64_decode($rurl);
		else 
			$rurl = 'index.php?option=com_arismartcontent&view=' . $this->getItemListName();

		$this->redirect($rurl);
	}
	
	function ajaxIsNameUnique()
	{
		$model = $this->getModelInstance();
		
		$name = JRequest::getString('name');
		$id = JRequest::getInt('id');
		
		return $model->isUniqueName($name, $id, $this->getType());
	}
	
	function _save($redirectOnError = true, $saveAsCopy = false)
	{
		$model = $this->getModelInstance(); 
		$data = JRequest::getVar('params', null, 'default', 'none', JREQUEST_ALLOWRAW);
		$settings = JRequest::getVar('settings', null, 'default', 'none', JREQUEST_ALLOWRAW);
		$formatterData = JRequest::getVar('formatter', null, 'default', 'none', JREQUEST_ALLOWRAW);

        if ($saveAsCopy)
        {
            $name = AriUtils::getParam($data, 'Name', '');

            $data['Id'] = 0;
            $data['Name'] = $model->getUniqueName($name);
        }

		$id = AriUtils::getParam($data, 'Id', 0);
		
		AriKernel::import('Joomla.Form.Form');

		$commonSettingsForm = new AriForm('commonSettings');
		$commonSettingsForm->load(AriSmartContentHelper::getFormPath('provider', 'source'));

		$providerSettingsForm = null;
		if ($this->getProviderSettingsFormName())
		{
			$providerSettingsForm = new AriForm('providerSettings');
			$providerSettingsForm->load(AriSmartContentHelper::getFormPath($this->getProviderSettingsFormName()));
		}
		
		$formatterForm = null;
		if ($this->getFormatterFormName())
		{
			$formatterForm = new AriForm('formatter');
			$formatterForm->load(AriSmartContentHelper::getFormPath($this->getFormatterFormName()));
		}
		
		$sourceSettingsForm = new AriForm('sourceSettings');
		$sourceSettingsForm->load(AriSmartContentHelper::getFormPath($this->getOriginalName()));

		$commonSettingsForm->bind($data);
		$sourceSettingsForm->bind($settings);
		if ($providerSettingsForm)
			$providerSettingsForm->bind($data);

		$clearFormatterData = array();
		if ($formatterForm)
		{
			$formatterForm->bind($formatterData);
			$formatterData = $formatterForm->toArray();
			$clearFormatterData = $formatterForm->toArray('system');
			$clearFormatterData['Data'] = $formatterData;
		}

		$cleanData = $commonSettingsForm->toArray();
		if ($providerSettingsForm)
			$cleanData = array_merge($cleanData, $providerSettingsForm->toArray());
		
		$cleanSettings = $sourceSettingsForm->toArray();
		
		$cleanData['_TypeName'] = $this->getType();

		if (!$commonSettingsForm->validate($cleanData) ||
			!$sourceSettingsForm->validate($cleanSettings) ||
			($providerSettingsForm && !$providerSettingsForm->validate($cleanData)) ||
			($formatterForm && !$formatterForm->validate($clearFormatterData))
			)
		{
			if ($redirectOnError)
			{
				$input = JFactory::getApplication()->input;
				$rurl = $input->get('rurl', null, 'RAW');
				
				$requestData = $data;
				$requestData['Params'] = $settings;
				$this->setRequestData($requestData);
				if ($id > 0)
					$this->redirect('index.php?option=com_arismartcontent&view=' . $this->getItemName() . '&task=edit&__MSG=COM_ARISMARTCONTENT_ERROR_ENTITYSAVE&Id=' . $id . ($rurl ? '&rurl=' . urlencode($rurl) : ''));
				else
					$this->redirect('index.php?option=com_arismartcontent&view=' . $this->getItemName() . '&task=add&__MSG=COM_ARISMARTCONTENT_ERROR_ENTITYSAVE' . ($rurl ? '&rurl=' . urlencode($rurl) : ''));
			}

			return null;
		}

		return $model->saveSource(
			$cleanData, 
			$cleanSettings,
			$this->getType(),
			$clearFormatterData
		);
	}
}