<?php
/*
 *
 * @package		ARI Smart Content
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

(defined('_JEXEC') && defined('ARI_FRAMEWORK_LOADED')) or die;

AriKernel::import('Joomla.Controllers.Controller');
AriKernel::import('Data.DataFilter');
AriKernel::import('Web.Controls.Data.MultiPageDataTable');

class AriSmartContentControllerSelectmodule extends AriController 
{
	function display()
	{
		$jInput = JFactory::getApplication()->input;
		$callback = $jInput->request->get('callback', null, 'RAW'); 
		
		$view = $this->getView();
		$view->display($callback);
	}

	protected function getModelInstance()
	{
		return $this->getModel('Modules');
	}
	
	function ajaxGetModuleList()
	{
		$model = $this->getModelInstance();

		$jInput = JFactory::getApplication()->input;
		$moduleType = $jInput->request->get('moduleType', null, 'RAW');

		$filter = new AriDataFilter(
			array(
				'startOffset' => 0, 
				'limit' => 10, 
				'sortField' => 'Name', 
				'dir' => 'asc'
			), 
			true
		);

		$totalCnt = $model->getModuleCount($moduleType, $filter);
		$filter->fixFilter($totalCnt);
		$items = $model->getModuleList($moduleType, $filter);

		$data = AriMultiPageDataTableControl::createDataInfo($items, $filter, $totalCnt); 

		return $data;
	}
}