<?php
/*
 *
 * @package		ARI Smart Content
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

(defined('_JEXEC') && defined('ARI_FRAMEWORK_LOADED')) or die;

AriKernel::import('Joomla.Controllers.Controller');
AriKernel::import('Data.DataFilter');
AriKernel::import('Web.Controls.Data.MultiPageDataTable');
AriKernel::import('Application.ARISmartContent.Providers.ProvidersHelper');

class AriSmartContentControllerSources extends AriController 
{
	function display()
	{
		$jInput = JFactory::getApplication()->input;
		$callback = $jInput->request->get('callback', null, 'RAW'); 
		$category = $jInput->request->get('cat', null, 'RAW');
		$sourceType = $jInput->request->get('sourceType', null, 'RAW');
		
		$view = $this->getView();
		$view->display($callback, $sourceType, $category);
	}

	function newSource()
	{
		$jInput = JFactory::getApplication()->input;
		$curl = $jInput->request->get('curl', null, 'RAW');
		$filter = $jInput->request->get('filter', null, 'RAW');
		$type = AriUtils::getParam($filter, 'SourceType');

		if ($curl)
		{
			$curl = base64_decode($curl);
			$curl = new JURI($curl);
			$curl->setVar('sourceType', $type);
			$curl = $curl->toString(array('path', 'query'));

			$curl = base64_encode($curl);
		}

		$type = explode('_', $type);
		$type = 'provider_' . $type[0] . '_source_' . $type[1];

		$this->redirect('index.php?option=com_arismartcontent&view=' . $type . '&task=add&tmpl=component' . ($curl ? '&rurl=' . urlencode($curl) : ''));
	}

	protected function getModelInstance()
	{
		return $this->getModel('Providersource');
	}

	function ajaxGetSourceList()
	{
		$model = $this->getModelInstance();

		$jInput = JFactory::getApplication()->input;
		$category = $jInput->request->get('cat', null, 'RAW');
		$sourceType = $jInput->request->get('sourceType', null, 'RAW');

		$filter = new AriDataFilter(
			array(
				'startOffset' => 0, 
				'limit' => 10, 
				'sortField' => 'Name', 
				'dir' => 'asc'
			), 
			true
		);

		$totalCnt = $model->getSourceCount($sourceType, $filter);
		$filter->fixFilter($totalCnt);
		$items = $model->getSourceList($sourceType, $filter);

		$data = AriMultiPageDataTableControl::createDataInfo($items, $filter, $totalCnt); 

		return $data;
	}
}