<?php
/*
 * Elements
 *
 * @package		Elements
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die ('Restricted access');

require_once dirname(__FILE__) . '/../kernel/class.AriKernel.php';

AriKernel::import('Xml.XmlHelper');
AriKernel::import('Web.JSON.JSON');

if (!class_exists('JElementList'))
	jimport('joomla.html.parameter.element.list');

class JElementAdvancedlist extends JElementList
{
	var	$_name = 'Advancedlist';

	function fetchElement($name, $value, &$node, $control_name, $bindData = false)
	{
		if ($bindData)
			$this->bindData($node);
		
		if (!(bool)AriXmlHelper::getAttribute($node, 'multiple'))
			return parent::fetchElement($name, $value, $node, $control_name);

		$class = AriXmlHelper::getAttribute($node, 'class', 'inputbox');
		$splitter = AriXmlHelper::getAttribute($node, 'splitter', ';');
		$size = intval(AriXmlHelper::getAttribute($node, 'size'), 10);
		if ($size < 1)
			$size = 5;

		$clearValue = $value;
		if ($clearValue)
			$clearValue = explode($splitter, $clearValue);

		$options = array ();
		foreach ($node->children() as $option)
		{
			$val = AriXmlHelper::getAttribute($option, 'value');
			$text = J3_0 ? (string)$option : $option->data();
			$options[] = JHTML::_('select.option', $val, JText::_($text));
		}

		$this->_includeAssets();
		
		$selId = uniqid('advlist_');
		
		$document =& JFactory::getDocument();
		$document->addScriptDeclaration(
			sprintf('window.addEvent("domready", function(){ new ARIAdvancedList(%s); });',
				json_encode(
					array(
						'selectId' => $selId,
						'hiddenId' => $control_name . $name,
						'splitter' => $splitter 
					)
				)
			)
		);
		
		return JHTML::_('select.genericlist',
			$options,
			null,
			'class="ari_advlist ari_advlist_multiple ' . $class . '"'  . ' multiple="multiple" ' . ' size="' . $size . '"',
			'value',
			'text',
			$clearValue,
			$selId) .
			'<input type="hidden" name="' . $control_name . '[' . $name . ']' . '" id="' . $control_name . $name . '" value="' . $value . '" />';
	}
	
	function bindData(&$node)
	{
		unset($node->option);

		$data = $this->getData($node);
		if (empty($data))
			return ;
			
		foreach ($data as $key => $value)
		{
			$option =& $node->addChild('option');
			$option->addAttribute('value', $key);
			AriXmlHelper::setData($option, $value);
		}
	}
	
	function getData(&$node)
	{
		return null;
	}
	
	function _includeAssets()
	{
		static $loaded;
		
		if ($loaded)
			return ;

		$filePath = str_replace(DS == '\\' ? '/' : '\\', DS, dirname(__FILE__));
		if (strlen(JPATH_ROOT) > 1)
			$filePath = str_replace(JPATH_ROOT, '', $filePath);
			
		$uri = JURI::root(true) . str_replace(DS, '/', $filePath) . '/';
			
		$document =& JFactory::getDocument();
		if (J3_0)
			$document->addScript($uri . 'advancedlist_3.js');
		else
			$document->addScript($uri . 'advancedlist.js');
			
		$loaded = true;
	}
}