<?php
/*
 * Elements
 *
 * @package		Elements
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

require_once dirname(__FILE__) . '/../kernel/class.AriKernel.php';

AriKernel::import('Joomla.Integration.K2.ArticleController');

if (!class_exists('JElementAdvancedlist'))
	require_once dirname(__FILE__) . DS . 'advancedlist.php';

class JElementK2category extends JElementAdvancedlist 
{
	var $_name = 'K2category';

	function fetchElement($name, $value, &$node, $control_name) 
	{
		return parent::fetchElement($name, $value, $node, $control_name, true);
	}

	function getData(&$node)
	{
		$ctrl = new AriK2ArticleController();
		$categories = $ctrl->getCategoriesTree();
		if (!is_array($categories) || count($categories) == 0)
			return null;
			
		$data = array();
		$this->populateData($categories, $data);

		return $data;
	}
	
	function populateData(&$categories, &$data)
	{
		foreach ($categories as &$category) 
		{
			$data[$category->id] = str_repeat('- ', $category->level) . $category->name;
			if ($category->childs)
				$this->populateData($category->childs, $data);
		}
	}
}