<?php
/*
 * ARI Framework Lite
 *
 * @package		ARI Framework Lite
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2009 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die ('Restricted access');

require_once dirname(__FILE__) . '/../kernel/class.AriKernel.php';

require_once JPATH_ADMINISTRATOR . '/components/com_arismartcontent/defines.php';
require_once JPATH_ADMINISTRATOR . '/components/com_arismartcontent/models/modules.php';

AriKernel::import('Utils.Utils');
AriKernel::import('Parameters.ParametersHelper');
AriKernel::import('Web.JSON.JSONHelper');
AriKernel::import('Xml.XmlHelper');

class JElementModuletypes extends JElement
{
	var	$_name = 'Moduletypes';

	function fetchElement($name, $value, &$node, $control_name)
	{
		$onChangeHandler = AriXmlHelper::getAttribute($node, 'onchange');
		$model = AriModel::getInstance('Modules', 'AriSmartContentModel');
		$types = $model->getModuleTypes();
		
		$noneLabel = AriXmlHelper::getAttribute($node, 'none_label');
		if ($noneLabel)
		{
			$emptyItem = new stdClass();
			$emptyItem->Type = '';
			$emptyItem->Name = JText::_($noneLabel);
			array_unshift($types, $emptyItem);
		}
		
		$attrs = array('class="inputbox"');
		
		if ($onChangeHandler)
			$attrs[] = sprintf('onchange="%1$s"',
				$onChangeHandler);

		return JHTML::_(
			'select.genericlist', 
			$types,
			$control_name . '[' . $name . ']', 
			join(' ', $attrs), 
			'Type', 
			'Name', 
			$value,
			$control_name . $name
		);
	}
}