<?php
/*
 *
 * @package		ARI Smart Content
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

(defined('_JEXEC') && defined('ARI_FRAMEWORK_LOADED')) or die;

AriKernel::import('Application.ARISmartContent.Providers.ProviderBase');
AriKernel::import('Utils.Utils');
AriKernel::import('SimpleTemplate.SimpleTemplate');
AriKernel::import('Web.JSON.JSON');
AriKernel::import('Parameters.ParametersHelper');
AriKernel::import('Joomla.Integration.K2.ArticleController');
AriKernel::import('Joomla.Integration.K2.ArticleSearchStruct');

class AriSmartContentProviderK2Articles extends AriSmartContentProviderBase
{
	function getData($source, $filter)
	{
		$params = $source->Params;
		$treeParams = AriParametersHelper::flatParametersToArray($params);
		$searchArticlesParams = AriUtils::getParam($treeParams, 'search', array());
		
		$searchParams = new AriK2ArticleSearchStruct();
		$searchParams->bindFromArray($searchArticlesParams);

		$ctrl = new AriK2ArticleController();
		$data = $ctrl->getArticleList(
			$searchParams, 
			(bool)AriUtils::getParam($searchArticlesParams, 'parsePluginTags', true)
		);

		return $data;
	}

	function getColumns($source)
	{
		return array(
			array(
				'name' => 'id'
			),
			array(
				'name' => 'title'
			),
			array(
				'name' => 'introtext'
			),
			array(
				'name' => 'fulltext'
			), 
			array(
				'name' => 'readmore_link'
			),
			array(
				'name' => 'created'
			),
			array(
				'name' => 'modified'
			),
			array(
				'name' => 'hits'
			)
		);
	}
}