<?php
/*
 *
 * @package		ARI Smart Content
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

(defined('_JEXEC') && defined('ARI_FRAMEWORK_LOADED')) or die;

AriKernel::import('Joomla.Tables.Table');
AriKernel::import('Web.JSON.JSON');
AriKernel::import('Utils.Utils');
AriKernel::import('Utils.ArrayHelper');
AriKernel::import('Utils.DateUtility');

require_once dirname(__FILE__) . '/providergroup.php';

class AriSmartContentTableProvidersettings extends AriTable
{
	var $Id;
	var $Name = '';
	var $GroupId;
	var $Params = null;
	var $Description = '';
	var $CreatedBy = 0;
	var $Created;
	var $ModifiedBy = 0;
	var $Modified = null;
	var $Group;
	
	function __construct(&$db) 
	{
		parent::__construct('#__arismartcontent_provider_settings', 'Id', $db);
		
		$this->Group = new AriSmartContentTableProvidergroup($db);

		$this->addRelation('GroupId', 'Group');
	}

	function store($updateNulls = false)
	{
		$this->Params = $this->Params ? json_encode($this->Params) : '';

		return parent::store($updateNulls);
	}

	function load($oid = null, $reset = true)
	{
		$result = parent::load($oid, $reset);

		if (!$result)
			return $result;

		if ($this->Params)
			$this->Params = json_decode($this->Params);

		return $result;
	}
	
	function loadDefault($groupId)
	{
		$result = $this->customLoad(array(&$this, '_loadDefault'), array($groupId), 0, 1);
		
		if (!$result)
			return $result;
			
		if ($this->Params)
			$this->Params = json_decode($this->Params);

		return $result;	
	}
	
	function _loadDefault($query, $queryParams, $groupId)
	{
		$db = $this->getDBO();
		$tblAlias = $queryParams['tblAlias'];

		$query->where(
			sprintf(
				'`%1$s`.GroupId = %2$d',
				$tblAlias,
				$groupId
			)
		);

		$query->where(
			sprintf(
				'`%1$s`.Default = "1"',
				$tblAlias
			)
		);
		
		return $query;
	}
}