<?php
/*
 *
 * @package		ARI Smart Content
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

(defined('_JEXEC') && defined('ARI_FRAMEWORK_LOADED')) or die;

require_once dirname(__FILE__) . '/../view.php';

AriKernel::import('Joomla.Form.Form');

class AriSmartContentViewSelectmodule extends AriSmartContentAdminView 
{
	function display($callback, $moduleType = null, $tpl = null) 
	{
		$filterForm = new AriForm('common');
		$filterForm->load(AriSmartContentHelper::getFormPath('modules', 'filters'));
		$filterForm->setParamAttribute('ModuleType', 'onchange', 'YAHOO.ARISoft.page.pageManager.modulesManager.changeFilters();');
		$filterForm->bind(array('ModuleType' => $moduleType), array('_default'));

		$this->assign('callback', $callback);
		$this->assignRef('filterForm', $filterForm);
		$this->assignRef('dtModules', $this->getModulesDataTable($moduleType));

		parent::display($tpl);
	}

	protected function getModulesDataTable($moduleType)
	{
		AriKernel::import('Web.Controls.Data.MultiPageDataTable');

		$columns = array(
			new AriDataTableControlColumn(
				array(
					'key' => '', 
					'label' => JText::_('COM_ARISMARTCONTENT_LABEL_NUMPOS'), 
					'formatter' => 'YAHOO.ARISoft.widgets.DataTable.formatters.formatPosition', 
					'className' => 'dtCenter dtColMin'
				)
			),
			new AriDataTableControlColumn(
				array(
					'key' => 'Id', 
					'label' => JText::_('COM_ARISMARTCONTENT_LABEL_ID'), 
					'className' => 'dtCenter dtColMin',
					'sortable' => true,
				)
			),
			new AriDataTableControlColumn(
				array(
					'key' => 'Name', 
					'label' => JText::_('COM_ARISMARTCONTENT_LABEL_NAME'), 
					'sortable' => true, 
					'formatter' => 'YAHOO.ARISoft.SmartContent.formatters.formatSelectModule'
				)
			),
			new AriDataTableControlColumn(
				array(
					'key' => 'TypeName', 
					'label' => JText::_('COM_ARISMARTCONTENT_LABEL_TYPE'), 
					'className' => 'dtColMin dtNoWrap'
				)
			),
		);

		$dataTable = new AriMultiPageDataTableControl(
			'dtSources',
			$columns, 
			array(
				'dataUrl' => 'index.php?option=com_arismartcontent&view=selectmodule&task=ajaxGetModuleList',
				'initialRequest' => '&adtInit=1&moduleType=' . $moduleType
			),
			AriSmartContentHelper::getPaginatorOptions()
		);

		return $dataTable;
	}
}