<?php
/*
 *
 * @package		ARI Smart Content
 * @author		ARI Soft
 * @copyright	Copyright (c) 2011 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

if (!defined('J3_0'))
{
	$version = new JVersion();
	define('J3_0', version_compare($version->getShortVersion(), '3.0.0', '>='));
}

class com_arismartcontentInstallerScript
{
	function preflight($type, $parent)
	{
		if ($type == 'install' || $type == 'update')
		{
			if ($this->_isLegacyComponentInstalled())
			{
				$app = JFactory::getApplication();
				$app->enqueueMessage(
					'The installation process was interrupted because "ARI Smart Content" v. 1.x is installed on your site. "ARI Smart Content" v. 2.0+ is not compatible with v. 1.x.', 
					'error'
				);
				
				return false;
			}
		}

		return true;
	}
	
	function postflight($type, $parent)
	{		
		if (J3_0 && ($type == 'install' || $type == 'update'))
			$this->_executeInstall();
			
		if ($type == 'install')
			$this->_registerDefaultDBConnection();

        if (J2_5 && ($type == 'install' || $type == 'update'))
            $parent->getParent()->setRedirectUrl('index.php?option=com_arismartcontent&view=install&hidemainmenu=1');
			
		return true;
	}

	function uninstall()
	{
		if (J3_0)
		{
			require_once dirname(__FILE__) . '/uninstall.php';
	
			if (function_exists('com_uninstall'))
				com_uninstall();
		}
	}

	function _executeInstall()
	{
		require_once dirname(__FILE__) . '/backend/install.php';

		if (function_exists('com_install'))
			com_install();
	}

	function _isLegacyComponentInstalled()
	{
		$path = JPATH_ADMINISTRATOR . '/components/com_arismartcontent/js';
		
		return @file_exists($path);
	}
	
	function _registerDefaultDBConnection()
	{
        $db = JFactory::getDBO();
        $db->setQuery(
            'SELECT COUNT(*) FROM #__arismartcontent_provider_settings S INNER JOIN #__arismartcontent_provider_settings_groups SG ON S.GroupId = SG.GroupId WHERE SG.SystemName = "database_connection" AND S.Default = 1'
        );
        $hasDefaultConnection = $db->loadResult() > 0;

        if ($hasDefaultConnection)
            return ;

		$adminPath = JPATH_ROOT . '/administrator/components/com_arismartcontent/';
		
		require_once $adminPath . 'kernel/class.AriKernel.php';
		require_once $adminPath . 'defines.php';

		AriKernel::import('Application.ARISmartContent.Utils.Helper');
		AriKernel::import('Joomla.Models.Model');
		AriKernel::import('Joomla.Form.Form');
		
		require_once JPATH_ROOT . '/administrator/components/com_arismartcontent/tables/providergroup.php';
		require_once JPATH_ROOT . '/administrator/components/com_arismartcontent/tables/providersettings.php';
		require_once JPATH_ROOT . '/administrator/components/com_arismartcontent/models/providergroup.php';
		require_once JPATH_ROOT . '/administrator/components/com_arismartcontent/models/providersettings.php';

		$commonSettingsForm = new AriForm('commonSettings');
		$commonSettingsForm->load(AriSmartContentHelper::getFormPath('provider', 'group'));

		$connectionForm = new AriForm('connectionForm');
		$connectionForm->load(AriSmartContentHelper::getFormPath('provider_database_group_connection'));

		$commonSettingsForm->bind(array('Name' => 'Connection to Joomla! database', 'Default' => 1));
		$connectionForm->bind(array('connection' => 'joomla'));

		$commonSettings = $commonSettingsForm->toArray();
		$connectionSettings = $connectionForm->toArray();

		$model = AriModel::getInstance('Providersettings', 'AriSmartContentModel');

		$model->saveSettings(
			$commonSettings, 
			$connectionSettings,
			'database_connection'
		);
	}
}